from django.urls import path

from . import models, views

app_name = "lectures"
urlpatterns = [
    path("", views.view_groups, name="view_groups"),
    path(
        "groups/<int:group_id>", views.view_group_lectures, name="view_group_lectures"
    ),
    path("lectures/<int:lecture_id>", views.view_lecture, name="view_lecture"),
    path(
        "lectures/materials/<str:pk>/file",
        views.LectureMaterialFileDownloadView.as_view(),
        name="download_material_file",
    ),
    path("lectures/<int:lecture_id>/rsvp", views.rsvp_lecture, name="rsvp_lecture"),
    path("lectors/<int:id>", views.view_lector, name="view_lector"),
    path(
        "lectures/registered",
        views.view_registered,
        name="view_registered",
    ),
    path(
        "search",
        views.search,
        name="search",
    ),
]
