import os

from django.core.files.storage import FileSystemStorage
from django_downloadview import StorageDownloadView
from django_http_exceptions import HTTPExceptions

# Create your views here.

storage = FileSystemStorage()


class MediaView(StorageDownloadView):
    attachment = False

    def get_path(self, *args, **kwargs) -> str:
        path = super().get_path(*args, **kwargs)

        # Make sure path is clean
        path = os.path.normpath(path)

        if path.startswith("_"):  # Private path
            raise HTTPExceptions.NOT_FOUND

        return path


view_media = MediaView.as_view(storage=storage)
