import $ from "jquery";

const showTimelineYear = () => {
    $(".__timeline-year").not(`#timeline-year-${window.currentTimelineYear}`).addClass("hidden");
    $(`#timeline-year-${window.currentTimelineYear}`).removeClass("hidden");
    $("#timeline-current-year").html(window.currentTimelineYear);

    $("#next-timeline-item").attr(
        "disabled",
        ($(`#timeline-year-${window.currentTimelineYear + 1}`).length === 0)
    );
    $("#previous-timeline-item").attr(
        "disabled",
        ($(`#timeline-year-${window.currentTimelineYear - 1}`).length === 0)
    );
}

const assignOpenerListeners = () => {
    $(".__lecture-category").on(
        "click",
        event => {
            if (
                !$(event.target).hasClass("__lecture-category-clickable")
                && !(event.target).closest(".__lecture-category-clickable").length === 0
            ) {
                return
            }

            if (event.currentTarget.dataset.isOpen === 'true') {
                $(event.currentTarget).
                find(".__lecture-category-opener").
                addClass("ico--chevron-down").
                removeClass("ico--chevron-up")

                event.currentTarget.dataset.isOpen = 'false'

                $(event.currentTarget).
                find(".__lecture-category-content").
                addClass("hidden")
            } else {
                $(event.currentTarget).
                find(".__lecture-category-opener").
                removeClass("ico--chevron-down").
                addClass("ico--chevron-up")

                event.currentTarget.dataset.isOpen = 'true'

                $(event.currentTarget).
                find(".__lecture-category-content").
                removeClass("hidden")
            }
        }
    )

    $(".__lecture").on(
        "click",
        event => {
            if (
                !$(event.target).hasClass("__lecture-clickable")
                && !(event.target).closest(".__lecture-clickable").length === 0
            ) {
                return
            } else {
                event.stopImmediatePropagation();
                event.preventDefault();
            }

            if (event.currentTarget.dataset.isOpen === 'true') {
                $(event.currentTarget).
                find(".__lecture-opener").
                addClass("ico--chevron-down").
                removeClass("ico--chevron-up")

                event.currentTarget.dataset.isOpen = 'false'

                $(event.currentTarget).
                find(".__lecture-content").
                addClass("hidden")
            } else {
                $(event.currentTarget).
                find(".__lecture-opener").
                removeClass("ico--chevron-down").
                addClass("ico--chevron-up")

                event.currentTarget.dataset.isOpen = 'true'

                $(event.currentTarget).
                find(".__lecture-content").
                removeClass("hidden")
            }
        }
    )
}

$(window).ready(
    () => {
        window.nextTimelineYear = () => {
            window.currentTimelineYear++;
            showTimelineYear();
        }

        window.previousTimelineYear = () => {
            window.currentTimelineYear--;
            showTimelineYear();
        }

        $(".__lecture-content").addClass("hidden")

        assignOpenerListeners()

        // Make sure our listeners exist
        setInterval(
            () => {
                const currentUrl = window.location.href;

                if (currentUrl != previousUrl) {
                    // URL changed
                    previousUrl = currentUrl;

                    const params = new Proxy(
                        new URLSearchParams(window.location.search), {
                        get: (searchParams, prop) => searchParams.get(prop),
                        }
                    )

                    if (
                        params.view !== null
                        && params.view === "recordings"
                    ) {
                        assignOpenerListeners()
                    }
                }
            },
            100
        )

        $(".switch__item").on(
            "click",
            event => {
                assignOpenerListeners()
            }
        )
    }
)
