import $ from "jquery";

import alertify from "alertifyjs";
import "alertifyjs/build/css/alertify.css";

import Cookies from "js-cookie";


$(window).ready(
    () => {
        $("#set-rsvp").on(
            "click",
            async (event) => {
                const body = new FormData();
                body.append("register", (!window.isRegistered).toString());

                let response = await fetch(
                    event.currentTarget.dataset.url,
                    {
                        method: "POST",
                        credentials: "include",
                        headers: {
                            "X-CSRFToken": Cookies.get("csrftoken")
                        },
                        body: body
                    }
                );

                try {
                    response = await response.json();
                } catch (e) {
                    alertify.error("Chyba při registraci - odpověď serveru.");
                    return;
                }

                if (response["success"]) {
                    window.isRegistered = !window.isRegistered;

                    if (window.isRegistered) {
                        event.currentTarget.innerHTML = "Zrušit registraci";
                        alertify.success("Školení zaregistrováno.");
                    } else {
                        event.currentTarget.innerHTML = "Zaregistrovat se";
                        alertify.success("Registrace zrušena.");
                    }
                } else {
                    alertify.error("Chyba při registraci - odmítnuta.");
                }
            }
        );
    }
);
